/* input.h -- input headers */

#ifndef INPUT_H
#define INPUT_H

/* includes */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <termios.h>

/* defines */
#define I_SUCCESS 1
#define I_ERROR -1

#define MENUE (1<<0)
#define CONNECTIONS (1<<1)

#define MAX_CONTENT 128

#define LINE_BUFFERED (1<<0)
#define CONTENT_BUFFER (1<<1)
#define INPUT_ECHO (1<<2)

/* input specific variables */
typedef struct s_input {
  char *content;
  int c_count;
  unsigned char mode;
  struct termios tios;
} t_input;

/* function prototypes */
int input_init(t_input *input);
int input_shutdown(t_input *input);
int input_get_event(t_input *input,int (*callback)(t_input *input,void *ptr),
                   void *ptr);

#endif
